import java.io.IOException;

public class Exo2{

    public Exo2(){
    }
    
    public static void main (String[] args) throws IOException{
	Exo2 exo=new Exo2();
	Genealogie gen=new Genealogie();
	Personne jeanne = new Personne("Jeanne", "Holly",21,false);
        Personne emilie = new Personne("Emilie", "Durant", 22,false);
        Personne jean = new Personne("Jean", "Dupond", 11,true);
	gen.marie(emilie,jean);
        Personne eric = new Personne("Eric", "Dupond", 12,true);
	eric.setPere(jean);
	eric.setMere(emilie);
	gen.marie(eric, jeanne);
	Personne yannick = new Personne("Yannick", "Dupond", 13,true);
        Personne sylvie  = new Personne("Sylvie", "France", 23,false);
        Personne brigitte = new Personne("Brigitte", "France", 24,false);
        brigitte.setMere(sylvie);
        yannick.setPere(eric);
        yannick.setMere(jeanne);
        Personne henri = new Personne("Henri", "Dupond", 14,true);
	henri.setPere(yannick);
	henri.setMere(brigitte);
        Personne charles = new Personne("Charles", "Tiers", 15,true);
        charles.setPere(jean);
	charles.setMere(emilie);
        
        gen.ajoute(henri);
	gen.ajoute(eric);
        gen.ajoute(emilie);
        gen.ajoute(jean);
        gen.ajoute(jeanne);
        gen.ajoute(sylvie);
        gen.ajoute(yannick);
        gen.ajoute(brigitte);
	gen.ajoute(charles);
	
	Keyboard keyboard=new Keyboard();
	int rep,secu,secu2;
	String prenom,nom,sexe;
	boolean end=false,estHomme;
	Personne p,p1,p2;
	Personne[] gp;

	
	System.out.println("Attention la liste gnalogique initiale n'est pas vide. ");
	

	while(!end){
	    System.out.println("");
	    System.out.println("> Que voulez-vous faire ?");
	    System.out.println("  1. Afficher la liste ?");
	    System.out.println("  2. Ajouter une personne ?");
	    System.out.println("  3. Rechercher une personne ?");
	    System.out.println("  4. Marier une personne a une autre ?");
	    System.out.println("  5. Afficher les grand-parents d'une personne ?");
	    System.out.println("  6. Tester si une personne est l'ancetre d'une autre ?");
	    System.out.println("  7. Tester si deux personnes sont de la meme famille ?");
	    System.out.println("  8. Afficher l'arbre genealogique d'une personne ?");
	    System.out.println("  9. Quitter ?");
	    System.out.print("  Choix : ");
	    rep=keyboard.getInt();
	    System.out.println("");
	    switch(rep){
	    case 1:
		System.out.println("> Affichage de la liste : ");
		gen.affiche();
		break;
	    case 2:
		System.out.println("> Ajout d'une nouvelle personne : ");
		System.out.print(" > Prenom ? ");
		prenom=keyboard.getString();
		System.out.print(" > Nom ? ");
		nom=keyboard.getString();
		System.out.print(" > Sexe (H/F) ? ");
		sexe=keyboard.getString();
		estHomme=(sexe.equals("H") || sexe.equals("h"));
		System.out.print(" > Num secu ? ");
		secu=keyboard.getInt();
		p=new Personne(prenom,nom,secu,estHomme);
		if(gen.ajoute(p)){
		    System.out.println(" ... ajouter a la liste");
		}
		else {
		    System.out.println(" ... deja present dans la liste.");
		}
		break;
	    case 3:
		System.out.println("> Recherche d'une personne : ");
		System.out.print(" > Prenom ? ");
		prenom=keyboard.getString();
		System.out.print(" > Nom ? ");
		nom=keyboard.getString();
		System.out.println("");
		gen.recherche(prenom,nom);
		break;
	    case 4:
		System.out.print(" > Numero de secu de la premiere ? ");
		secu=keyboard.getInt();
		p1=gen.recherche(secu);
		System.out.print(" > Numero de secu de la deuxieme ? ");
		secu=keyboard.getInt();
		p2=gen.recherche(secu);
		if(p1==null || p2==null){
		    System.out.println(" ... un des deux numeros de secu n'existe pas.");
		}
		else{
		    gen.marie(p1,p2);
		}
		break;
	    case 5:
		System.out.print(" > Numero de secu de la personne ? ");
		secu=keyboard.getInt();
		p1=gen.recherche(secu);
		if(p1==null){
		    System.out.println(" ... ce numero n'est pas enregistre");
		}
		else{
		    gp=gen.grandParents(p1);
		    if(gp[0]==null){		
			System.out.println("  Grand pere paternel inconnu");
		    }
		    else{
			System.out.println("  Grand pere paternel : "+gp[0]);
		    }
		    if(gp[1]==null){		
			System.out.println("  Grand mere paternelle inconnue");
		    }
		    else{
			System.out.println("  Grand mere paternelle : "+gp[1]);
		    }
		    if(gp[2]==null){		
			System.out.println("  Grand pere maternel inconnu");
		    }
		    else{
			System.out.println("  Grand pere maternel : "+gp[2]);
		    }
		    if(gp[3]==null){		
			System.out.println("  Grand mere maternelle inconnue");
		    }
		    else{
			System.out.println("  Grand mere maternelle : "+gp[3]);
		    }
		}
		break;
	    case 6:
		System.out.print(" > Numero de secu de l'ancetre ? ");
		secu=keyboard.getInt();
		p1=gen.recherche(secu);
		System.out.print(" > Numero de secu de la personne a testee ? ");
		secu=keyboard.getInt();
		p2=gen.recherche(secu);
		if(p1==null || p2==null){
		    System.out.println(" ... un des deux numeros de secu n'existe pas.");
		}
		else{
		    System.out.print("  "+p2+" ");
		    if(p2.aPourAncetre(p1)){
			System.out.print("est l'ancetre de");
		    }
		    else{
			System.out.print("n'est pas l'ancetre de");
		    }
		    System.out.println("  "+p1);
		}	
		
		break;
	    case 7:
		System.out.print(" > Numero de secu de la premiere ? ");
		secu=keyboard.getInt();
		p1=gen.recherche(secu);
		System.out.print(" > Numero de secu de la deuxieme ? ");
		secu=keyboard.getInt();
		p2=gen.recherche(secu);
		if(p1==null || p2==null){
		    System.out.println(" ... un des deux numeros de secu n'existe pas.");
		}
		else{
		    System.out.print(" "+p1+" et "+p2);
		    if(gen.memeFamille(p1,p2)){
			System.out.println(" sont de la meme famille.");
		    }
		    else{
			System.out.println(" ne sont pas de la meme famille.");
		    }
		}
		break;
	    case 8:
		System.out.print(" > Numero de secu de la personne ? ");
		secu=keyboard.getInt();
		p1=gen.recherche(secu);
		if(p1==null){
		    System.out.println(" ... ce numero n'est pas enregistre");
		}
		else{
		    System.out.println(gen.afficheArbre(p1,1));
		}
		break;
	    default:
		end=true;
		break;
	    }
	}
		

        /*System.out.println(gen.afficheGen(henri, 1));
        gen.grandParents(henri);

        System.out.println("Jean est l'ancetre d'Henri " +henri.estAncetre(jean));
        
        System.out.println(gen.afficheGen(charles, 1));
        
        System.out.println("Henri et Charles sont de la meme famille : " + gen.memeFamille(henri, charles));*/

        

    }
}