import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

public class Keyboard{
    
    public Keyboard(){
    }

    /* -----------------------------------------------------
      | public String getStringFromKeyboard()               |
      | ----------------------------------------------------|
      | Rcupre une chane de caractre entre au clavier. |
       -----------------------------------------------------
    */

    public String getString() throws IOException{
	InputStreamReader reader=new InputStreamReader(System.in);
	BufferedReader buffer = new BufferedReader(reader);
	return buffer.readLine();
    }
 
    /* ----------------------------------------------
      | public int getIntFromKeyboard()              | 
      | ---------------------------------------------|
      | Rcupre un nombre entier saisie au clavier. |
       ----------------------------------------------
    */

    public int getInt() throws IOException{
	String str;
	int n=0;
	boolean end=false;
	while(!end){
	    str=getString();
	    end=true;
	    try{
		n=Integer.parseInt(str);
	    }
	    catch(NumberFormatException e){
		System.err.println("Erreur: Un entier est attendu.");
		end=false;
	    }
	}
	return n;
    }
}
