public class SuiteGeomTab{
    private long[] tab;
    private int raison;
    private int taille; //nombre d'elements stocks
    private int capacite; //nombre d'elements pouvant tre stocks
    
    public SuiteGeomTab(){
	this(1,1,1);
    }

    public SuiteGeomTab(int n,int q,long u0){
	tab=new long[1];
	tab[0]=u0;
	taille=capacite=1;
	raison=q;
	ajouteTermes(n-1);
    }
    
    public void agrandir(){
	System.out.println("Agrandir");
	capacite*=2; //On double la taille des qu'on agrandit
	long[] newTab=new long[capacite];
	for(int i=0;i<taille;i++){
	    newTab[i]=tab[i];
	}
	this.tab=newTab;
    }
	
    public void ajouteTermes(int n){
	while(capacite<taille+n){
	    agrandir();
	}
	for(int i=taille;i<taille+n;i++){
	    tab[i]=tab[i-1]*raison;
	}
	taille+=n;
    }

    public long getTerme(int n){
	if(taille<n+1){
	    ajouteTermes(n+1-taille);
	}
	return tab[n];//On retourne u_n et pas u_(n-1)
    }
    
    @Override
    public String toString(){
	String str="[taille = "+Integer.toString(taille)+", capacite = "+Integer.toString(capacite)+"] \n  Tab = ";
	for(int i=0;i<taille;i++){
	     str = str+tab[i]+ " ";
	}
	return str;
    }

}
