public class SuiteGeomList{
    private Noeud premier;
    private int raison;

    SuiteGeomList(){
	this(1,1,1);
    }

    SuiteGeomList(int n,int q,long u0){
	Noeud cour,nouv;
	premier=new Noeud(u0);
	raison=q;
	cour=premier;
	for(int i=1;i<n;i++){
	    nouv=new Noeud((Long)(cour.getVal())*raison);
	    cour.setSuiv(nouv);
	    cour=nouv;
	}
    }
    
    void ajouteTermes(int n){
	Noeud cour=premier;
	while(cour.getSuiv()!=null){//On a au moins un terme dans la suite donc la liste est non vide
	    cour=cour.getSuiv();
	}
	for(int i=0;i<n;i++){
	    cour.setSuiv(new Noeud((Long)(cour.getVal())*raison));
	    cour=cour.getSuiv();
	}
    }

    long getTerme(int n){
	Noeud cour=premier;
	Noeud prec=null;
	int i=0;
	while(cour!=null && i<n){
	    prec=cour;
	    cour=cour.getSuiv();
	    i++;
	}
	if(cour!=null){
	    return (Long)(cour.getVal());
	}
	//Il nous manque des termes
	cour=prec; // cour est maintenant le noeud englobant la derniere valeur deja calculee
	for(;i<=n;i++){
	    cour.setSuiv(new Noeud((Long)(cour.getVal())*raison));
	    cour=cour.getSuiv();
	}
	return (Long)(cour.getVal());
    }

    @Override
    public String toString(){
	Noeud cour=premier;
	String str="";
	while(cour!=null){
	    str=str+cour.getVal()+" ";
	    cour=cour.getSuiv();
	}
	return str;
    }
}